/******************************************************************************
 * Copyright 2022 Daniel Dietrich
 * This program and the accompanying materials are made available under the
 * terms of the MIT License, which is available in the project root.
 ******************************************************************************/
export declare type Is<T1, T2> = (<T>() => T extends T2 ? true : false) extends (<T>() => T extends T1 ? true : false) ? true : false;
export declare type Extends<A1, A2> = [
    A1
] extends [never] ? true : [
    A2
] extends [never] ? false : [
    any
] extends [A2] ? true : [
    unknown
] extends [A2] ? true : [
    any
] extends [A1] ? false : [
    unknown
] extends [A1] ? false : A1 extends A2 ? true : false;
export declare type And<C1 extends boolean, C2 extends boolean> = C1 extends true ? C2 extends true ? true : false : false;
export declare type Or<C1 extends boolean, C2 extends boolean> = C1 extends true ? true : C2 extends true ? true : false;
export declare type Not<C extends boolean> = C extends true ? false : true;
export declare type TupleToIntersection<T extends any[]> = UnionToIntersection<TupleToUnion<T>>;
export declare type TupleToUnion<T extends any[]> = T[number];
export declare type UnionToIntersection<U> = (U extends any ? (arg: U) => void : never) extends ((arg: infer I) => void) ? I : never;
export declare type UnionToTuple<T, L = LastOf<T>> = [
    T
] extends [never] ? [] : [...UnionToTuple<Exclude<T, L>>, L];
declare type LastOf<T> = UnionToIntersection<T extends any ? () => T : never> extends () => infer R ? R : never;
export {};
//# sourceMappingURL=utilities.d.ts.map